#include <stdlib.h>
#include <stdbool.h>
#include <avr/io.h>

#include "menu.h"
#include "display.h"

int state;
char buff[17];

void menu_draw_current()
{
	display_goto(ROW_ONE, 0);		
	display_clock(hours, minutes, seconds, buff);		
	display_text(" CURRENT");

	display_goto(ROW_TWO, 0);
	display_num(ctemp, buff);
	display_char(0xDF);	
	display_text("C  ");

	display_goto(ROW_TWO, 8);
	display_num(chum, buff);
	display_text("%RH");	
}

void menu_draw_min()
{
	display_goto(ROW_ONE, 0);		
	display_clock(hours, minutes, seconds, buff);		
	display_text(" MIN");

	display_goto(ROW_TWO, 0);
	display_num(mintemp, buff);
	display_char(0xDF);	
	display_text("C  ");

	display_goto(ROW_TWO, 8);
	display_num(minhum, buff);
	display_text("%RH");	
}

void menu_draw_max()
{
	display_goto(ROW_ONE, 0);		
	display_clock(hours, minutes, seconds, buff);		
	display_text(" MAX");

	display_goto(ROW_TWO, 0);
	display_num(maxtemp, buff);
	display_char(0xDF);	
	display_text("C  ");

	display_goto(ROW_TWO, 8);
	display_num(maxhum, buff);
	display_text("%RH");	
}

void menu_reset()
{
	hours = 0;
	minutes = 0;
	seconds = 0;
	maxtemp = ctemp;
	mintemp = ctemp;
	maxhum = chum;
	minhum = chum;
}

void menu_keypress(char btn)
{
	switch (btn) {
		case BUTTON_RESET:
			menu_reset();			
			menu_draw();
			break;

		case BUTTON_MODE:			
			state = (state + 1) % NUM_SCREENS;
			display_clear();
			menu_draw();
			break;
	}
}

void menu_draw()
{	
	switch (state) {
		case SCREEN_CURRENT:
			menu_draw_current();
			break;

		case SCREEN_MIN:
			menu_draw_min();
			break;		

		case SCREEN_MAX:
			menu_draw_max();
			break;		
	}
}

void menu_init()
{
	state = SCREEN_CURRENT;
	display_init();
}
