#include <stdlib.h>
#include <stdbool.h>
#include <avr/io.h>

void temp_init()
{	
	/* Uses AREF Pin */
	ADMUX = 0;
	
	/* Set auto trigger source to Timer1 Overflow int */
	// SFIOR = _BV(ADTS2) | _BV(ADTS1);

	/* A/D Enable, Auto trigger enabled, ADC Interrupt Enable, Prescaler 16 */
	// ADCSRA = _BV(ADSC) | _BV(ADATE) | _BV(ADIE) | _BV(ADPS2); 

	/* No autotrigger, prescaler 16, ADC Interrupts Enabled */
	ADCSRA = _BV(ADIE) | _BV(ADPS2);	
}

/* Enable and start A/D conversion */
void temp_sample()
{
	ADCSRA |= _BV(ADEN) | _BV(ADSC);
}

/* Stop A/D component (to save power), and return last read value */
int temp_value()
{		
	ADCSRA &= ~_BV(ADEN);

	float percent = ADCW/((float) 1023);
	float voltage = percent * 5.15;
	float kelvin = voltage*100;

	return (int) (kelvin - 273);
}
